import json

"""
>>> INPUT: '{"author": "truocphan", "version": "22.3.3", "version": "latest", "release": [{"version": "22.3.3", "version": "latest"}], "snapshot": {"author": "truocphan", "version": "22.3.3", "release": [{"version": "latest"}]}}'

<<< OUTPUT: {'author': 'truocphan', 'version': '22.3.3', 'version{{{2}}}': 'latest', 'release': [{'version': '22.3.3', 'version{{{2}}}': 'latest'}], 'snapshot': {'author': 'truocphan', 'version': '22.3.3', 'release': [{'version': 'latest'}]}}
"""
def loads(Jstr):
	import re

	def __convert_Jstr_to_Jobj(Jstr, Jobj):
		if type(Jstr) == dict:
			for k in Jstr.keys():
				if re.split("{{{\d+}}}$", k)[0] not in Jobj.keys():
					if type(Jstr[k]) not in [list, dict]:
						Jobj[re.split("{{{\d+}}}$", k)[0]] = Jstr[k]
					else:
						if type(Jstr[k]) == list:
							Jobj[re.split("{{{\d+}}}$", k)[0]] = list()
						else:
							Jobj[re.split("{{{\d+}}}$", k)[0]] = dict()

						__convert_Jstr_to_Jobj(Jstr[k], Jobj[re.split("{{{\d+}}}$", k)[0]])

				else:
					if type(Jstr[k]) not in [list, dict]:
						Jobj[re.split("{{{\d+}}}$", k)[0]+"{{{"+str(len([i for i in Jobj.keys() if re.split("{{{\d+}}}$", k)[0]==re.split("{{{\d+}}}$", i)[0]]) + 1)+"}}}"] = Jstr[k]
					else:
						if type(Jstr[k]) == list:
							Jobj[re.split("{{{\d+}}}$", k)[0]+"{{{"+str(len([i for i in Jobj.keys() if re.split("{{{\d+}}}$", k)[0]==re.split("{{{\d+}}}$", i)[0]]) + 1)+"}}}"] = list()
						else:
							Jobj[re.split("{{{\d+}}}$", k)[0]+"{{{"+str(len([i for i in Jobj.keys() if re.split("{{{\d+}}}$", k)[0]==re.split("{{{\d+}}}$", i)[0]]) + 1)+"}}}"] = dict()

						__convert_Jstr_to_Jobj(Jstr[k], Jobj[re.split("{{{\d+}}}$", k)[0]+"{{{"+str(len([i for i in Jobj.keys() if re.split("{{{\d+}}}$", k)[0]==re.split("{{{\d+}}}$", i)[0]]))+"}}}"])

		elif type(Jstr) == list:
			for i in range(len(Jstr)):
				if type(Jstr[i]) not in [list, dict]:
					Jobj.append(Jstr[i])
				else:
					if type(Jstr[i]) == list:
						Jobj.append(list())
					else:
						Jobj.append(dict())

					__convert_Jstr_to_Jobj(Jstr[i], Jobj[i])

	try:
		if type(json.loads(Jstr)) in [list, dict]:
			if len(json.loads(Jstr)) == 0:
				return json.loads(Jstr)
			else:
				i = 0
				while re.search(r'"((?:\w|\\"|\s)+)"[\s\t\n]*:', Jstr):
					Jstr = re.sub(r'"((?:\w|\\"|\s)+)"[\s\t\n]*:', r'"\1{{{'+str(i)+'}}}":', Jstr, 1)
					i += 1

				if type(json.loads(Jstr)) == list:
					Jobj = list()
				else:
					Jobj = dict()

				__convert_Jstr_to_Jobj(json.loads(Jstr), Jobj)

				return Jobj
	except Exception as e:
		print(e)

	return dict()



"""
>>> INPUT: {'author': 'truocphan', 'version': '22.3.3', 'version{{{2}}}': '22.3.14', 'release': [{'version': '22.3.3', 'version{{{2}}}': 'latest'}], 'snapshot': {'author': 'truocphan', 'version': '22.3.3', 'release': [{'version': 'latest'}]}}

<<< OUTPUT: '{"author": "truocphan", "version": "22.3.3", "version": "22.3.14", "release": [{"version": "22.3.3", "version": "latest"}], "snapshot": {"author": "truocphan", "version": "22.3.3", "release": [{"version": "latest"}]}}'
"""
def dumps(Jobj, skipkeys=False, ensure_ascii=True, check_circular=True, allow_nan=True, cls=None, indent=None, separators=None, default=None, sort_keys=False):
	import re
	return re.sub("{{{\d+}}}", "", json.dumps(Jobj, skipkeys=skipkeys, ensure_ascii=ensure_ascii, check_circular=check_circular, allow_nan=allow_nan, cls=cls, indent=indent, separators=separators, default=default, sort_keys=sort_keys))



"""
>>> INPUT: '{"author": "truocphan", "version": "22.3.3", "version": "22.3.14", "release": [{"version": "22.3.3", "version": "latest"}], "snapshot": {"author": "truocphan", "version": "22.3.3", "release": [{"version": "latest"}]}}'

<<< OUTPUT: {'author': 'truocphan', 'version': '22.3.3', 'version{{{2}}}': '22.3.14', 'release||$0$||version': '22.3.3', 'release||$0$||version{{{2}}}': 'latest', 'snapshot||author': 'truocphan', 'snapshot||version': '22.3.3', 'snapshot||release||$0$||version': 'latest'}

+ Reference: https://github.com/gaojiuli/flatjson/blob/master/flatjson/__init__.py
"""
def flatten(Jobj, separator="||", parse_index="$"):
	Jflat = dict()

	def __convert_Jobj_to_Jflat(Jobj, key=None):
		if type(Jobj) == dict:
			if len(Jobj) == 0:
				Jflat[key] = dict()
			else:
				for k,v in Jobj.items():
					_Jobj = v
					_key = "{key}{separator}{k}".format(key=key,separator=separator,k=k) if key else "{k}".format(k=k)

					__convert_Jobj_to_Jflat(_Jobj, _key)

		elif type(Jobj) == list:
			if len(Jobj) == 0:
				Jflat[key] = list()
			else:
				for i,v in enumerate(Jobj):
					_Jobj = v
					_key = "{key}{separator}{parse_index}{i}{parse_index}".format(key=key, separator=separator, parse_index=parse_index, i=i) if key else "{parse_index}{i}{parse_index}".format(parse_index=parse_index, i=i)

					__convert_Jobj_to_Jflat(_Jobj, _key)

		else:
			Jflat[key] = Jobj

	try:
		if type(Jobj) in [list, dict] and len(Jobj) > 0:
			__convert_Jobj_to_Jflat(Jobj)
			return Jflat
	except Exception as e:
		print(e)

	return dict()



"""
>>> INPUT: {'author': 'truocphan', 'version': '22.3.3', 'version{{{2}}}': '22.3.14', 'release||$0$||version': '22.3.3', 'release||$0$||version{{{2}}}': 'latest', 'snapshot||author': 'truocphan', 'snapshot||version': '22.3.3', 'snapshot||release||$0$||version': '22.3.14'}

<<< OUTPUT: {'author': 'truocphan', 'version': '22.3.3', 'version{{{2}}}': '22.3.14', 'release': [{'version': '22.3.3', 'version{{{2}}}': 'latest'}], 'snapshot': {'author': 'truocphan', 'version': '22.3.3', 'release': [{'version': '22.3.14'}]}}

+ Reference: https://github.com/drg0072/json_flatten/blob/master/json_python_flatten/unflatten.py
"""
def unflatten(Jflat, separator="||", parse_index="$"):
	import re

	Jobj = dict()

	for k, v in Jflat.items():
		temp_dict = Jobj
		Jkeys = k.split(separator)

		for count, (index, next_Jkeys) in enumerate(zip(Jkeys, Jkeys[1:] + [v]), 1):
			v = next_Jkeys if count == len(Jkeys) else [] if re.compile(re.escape(parse_index)+"\d+"+re.escape(parse_index)).match(next_Jkeys) else {}

			if type(temp_dict) == list:
				index = int(re.compile(re.escape(parse_index)+"(\d+)"+re.escape(parse_index)).match(index).group(1))

				while index >= len(temp_dict):
					temp_dict.append(v)

			elif index not in temp_dict:
				temp_dict[index] = v

			temp_dict = temp_dict[index]

	return Jobj